package com.zipline.back.controller;

import com.zipline.back.dao.PostRepository;
import com.zipline.back.dao.UserRepository;
import com.zipline.back.model.Post;
import com.zipline.back.model.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;


@RestController
@RequestMapping("/post")
public class PostController {
    @Autowired
    private UserRepository userRepo;
    @Autowired
    private PostRepository postRepo;

    @PostMapping("{githubId}/new-post")
    @ResponseStatus(HttpStatus.OK)
    public Post createPost (
            @PathVariable String githubId,
            @RequestBody Post post
    ) {
        post.setUser(userRepo.findByGithubId(githubId));
        post.setTimestamp(LocalDateTime.now());
        post.setSender(githubId);
        return postRepo.save(post);
    }

    @GetMapping("/{githubId}")
    public Iterable<Post> getUserPosts (
            @PathVariable String githubId
    ) {
        return postRepo.findAllByUserId(userRepo.findByGithubId(githubId).getId());
    }

    @GetMapping("/all")
    public Iterable<Post> findAllPosts () {
        return postRepo.findAll();
    }
}
