package com.zipline.back.controller;

import com.zipline.back.dao.UserRepository;
import com.zipline.back.model.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/user")
public class UserController {
    @Autowired
    private UserRepository userRepo;

    @PostMapping("/new-user")
    @ResponseStatus(HttpStatus.OK)
    public User createUser(
            @RequestBody User user
    ) {
        return userRepo.save(user);
    }

    @GetMapping("/{githubId}")
    public User getUser (
            @PathVariable String githubId
    ) {
        return userRepo.findByGithubId(githubId);
    }

    @GetMapping("/all")
    public Iterable<User> findAllUsers () {
        return userRepo.findAll();
    }
}
